diff --git a/src/preprocessors/spp_stream5.c b/src/preprocessors/spp_stream5.c
index bbf1eeb..d40104d 100644
--- a/src/preprocessors/spp_stream5.c
+++ b/src/preprocessors/spp_stream5.c
@@ -53,6 +53,7 @@
 #include "snort_stream5_session.h"
 #include "snort_stream5_tcp.h"
 #include "snort_stream5_udp.h"
+#include "snort_stream5_sctp.h"
 #include "snort_stream5_icmp.h"
 #include "snort_stream5_ip.h"
 #include "checksum.h"
@@ -83,6 +84,7 @@
 PreprocStats s5PerfStats;
 extern PreprocStats s5TcpPerfStats;
 extern PreprocStats s5UdpPerfStats;
+extern PreprocStats s5SctpPerfStats;
 extern PreprocStats s5IcmpPerfStats;
 extern PreprocStats s5IpPerfStats;
 #endif
@@ -90,6 +92,7 @@ extern PreprocStats s5IpPerfStats;
 extern OptTreeNode *otn_tmp;
 extern Stream5SessionCache *tcp_lws_cache;
 extern Stream5SessionCache *udp_lws_cache;
+extern Stream5SessionCache *sctp_lws_cache;
 extern Stream5SessionCache *icmp_lws_cache;
 extern Stream5SessionCache *ip_lws_cache;
 
@@ -110,6 +113,7 @@ extern FlushConfig ignore_flush_policy_protocol[MAX_PROTOCOL_ORDINAL];
 #define S5_RIDICULOUS_MAX_SESSIONS 1024*1024 /* 1 million sessions */
 #define S5_DEFAULT_MAX_TCP_SESSIONS 262144 /* 256k TCP sessions by default */
 #define S5_DEFAULT_MAX_UDP_SESSIONS 131072 /* 128k UDP sessions by default */
+#define S5_DEFAULT_MAX_SCTP_SESSIONS 262144 /* 256k SCTP sessions by default */
 #define S5_DEFAULT_MAX_ICMP_SESSIONS 65536 /* 64k ICMP sessions by default */
 #define S5_DEFAULT_MAX_IP_SESSIONS   16384 /* 16k IP sessions by default */
 #define S5_MIN_PRUNE_LOG_MAX     1024      /* 1k packet data stored */
@@ -130,6 +134,7 @@ tSfPolicyUserContextId s5_config = NULL;
 Stream5GlobalConfig *s5_global_eval_config = NULL;
 Stream5TcpConfig *s5_tcp_eval_config = NULL;
 Stream5UdpConfig *s5_udp_eval_config = NULL;
+Stream5SctpConfig *s5_sctp_eval_config = NULL;
 Stream5IcmpConfig *s5_icmp_eval_config = NULL;
 Stream5IpConfig *s5_ip_eval_config = NULL;
 
@@ -138,7 +143,7 @@ uint32_t mem_in_use = 0;
 uint32_t firstPacketTime = 0;
 Stream5Stats s5stats;
 MemPool s5FlowMempool;
-static PoolCount s_tcp_sessions = 0, s_udp_sessions = 0;
+static PoolCount s_tcp_sessions = 0, s_udp_sessions = 0, s_sctp_sessions = 0;
 static PoolCount s_icmp_sessions = 0, s_ip_sessions = 0;
 static int s_proto_flags = 0;
 
@@ -153,6 +158,7 @@ static void Stream5GlobalInit(char *);
 static void Stream5ParseGlobalArgs(Stream5GlobalConfig *, char *);
 static void Stream5PolicyInitTcp(char *);
 static void Stream5PolicyInitUdp(char *);
+static void Stream5PolicyInitSctp(char *);
 static void Stream5PolicyInitIcmp(char *);
 static void Stream5PolicyInitIp(char *);
 static void Stream5CleanExit(int, void *);
@@ -172,6 +178,7 @@ tSfPolicyUserContextId s5_swap_config = NULL;
 static void Stream5GlobalReload(char *);
 static void Stream5TcpReload(char *);
 static void Stream5UdpReload(char *);
+static void Stream5SctpReload(char *);
 static void Stream5IcmpReload(char *);
 static void Stream5IpReload(char *);
 static int Stream5ReloadVerify(void);
@@ -439,6 +446,7 @@ void SetupStream5(void)
     RegisterPreprocessor("stream5_global", Stream5GlobalInit);
     RegisterPreprocessor("stream5_tcp", Stream5PolicyInitTcp);
     RegisterPreprocessor("stream5_udp", Stream5PolicyInitUdp);
+    RegisterPreprocessor("stream5_sctp", Stream5PolicyInitSctp);
     RegisterPreprocessor("stream5_icmp", Stream5PolicyInitIcmp);
     RegisterPreprocessor("stream5_ip", Stream5PolicyInitIp);
 #else
@@ -448,6 +456,8 @@ void SetupStream5(void)
                          Stream5TcpReload, NULL, NULL);
     RegisterPreprocessor("stream5_udp", Stream5PolicyInitUdp,
                          Stream5UdpReload, NULL, NULL);
+    RegisterPreprocessor("stream5_sctp", Stream5PolicyInitSctp,
+                         Stream5SctpReload, NULL, NULL);
     RegisterPreprocessor("stream5_icmp", Stream5PolicyInitIcmp,
                          Stream5IcmpReload, NULL, NULL);
     RegisterPreprocessor("stream5_ip", Stream5PolicyInitIp,
@@ -473,6 +483,7 @@ static void Stream5GlobalInit(char *args)
         RegisterPreprocessorProfile("s5", &s5PerfStats, 0, &totalPerfStats);
         RegisterPreprocessorProfile("s5tcp", &s5TcpPerfStats, 1, &s5PerfStats);
         RegisterPreprocessorProfile("s5udp", &s5UdpPerfStats, 1, &s5PerfStats);
+        RegisterPreprocessorProfile("s5sctp", &s5SctpPerfStats, 1, &s5PerfStats);
         RegisterPreprocessorProfile("s5icmp", &s5IcmpPerfStats, 1, &s5PerfStats);
         RegisterPreprocessorProfile("s5ip", &s5IpPerfStats, 1, &s5PerfStats);
 #endif
@@ -515,6 +526,8 @@ static void Stream5GlobalInit(char *args)
     pCurrentPolicyConfig->global_config->max_tcp_sessions = S5_DEFAULT_MAX_TCP_SESSIONS;
     pCurrentPolicyConfig->global_config->track_udp_sessions = S5_TRACK_YES;
     pCurrentPolicyConfig->global_config->max_udp_sessions = S5_DEFAULT_MAX_UDP_SESSIONS;
+    pCurrentPolicyConfig->global_config->track_sctp_sessions = S5_TRACK_YES;
+    pCurrentPolicyConfig->global_config->max_sctp_sessions = S5_DEFAULT_MAX_SCTP_SESSIONS;
     pCurrentPolicyConfig->global_config->track_icmp_sessions = S5_TRACK_NO;
     pCurrentPolicyConfig->global_config->max_icmp_sessions = S5_DEFAULT_MAX_ICMP_SESSIONS;
     pCurrentPolicyConfig->global_config->track_ip_sessions = S5_TRACK_NO;
@@ -533,11 +546,12 @@ static void Stream5GlobalInit(char *args)
     if ((!pCurrentPolicyConfig->global_config->disabled) &&
         (pCurrentPolicyConfig->global_config->track_tcp_sessions == S5_TRACK_NO) &&
         (pCurrentPolicyConfig->global_config->track_udp_sessions == S5_TRACK_NO) &&
+        (pCurrentPolicyConfig->global_config->track_sctp_sessions == S5_TRACK_NO) &&
         (pCurrentPolicyConfig->global_config->track_icmp_sessions == S5_TRACK_NO) &&
         (pCurrentPolicyConfig->global_config->track_ip_sessions == S5_TRACK_NO))
     {
         FatalError("%s(%d) ==> Stream5 enabled, but not configured to track "
-                   "TCP, UDP, ICMP, or IP.\n", file_name, file_line);
+                   "TCP, UDP, SCTP, ICMP, or IP.\n", file_name, file_line);
     }
 
     if (policy_id != getDefaultPolicy())
@@ -546,6 +560,8 @@ static void Stream5GlobalInit(char *args)
             pDefaultPolicyConfig->global_config->max_tcp_sessions;
         pCurrentPolicyConfig->global_config->max_udp_sessions =
             pDefaultPolicyConfig->global_config->max_udp_sessions;
+        pCurrentPolicyConfig->global_config->max_sctp_sessions =
+            pDefaultPolicyConfig->global_config->max_sctp_sessions;
         pCurrentPolicyConfig->global_config->max_icmp_sessions =
             pDefaultPolicyConfig->global_config->max_icmp_sessions;
         pCurrentPolicyConfig->global_config->max_ip_sessions =
@@ -581,8 +597,9 @@ static void Stream5ParseGlobalArgs(Stream5GlobalConfig *config, char *args)
     char *endPtr = NULL;
 #define MAX_TCP 0x01
 #define MAX_UDP 0x02
-#define MAX_ICMP 0x04
-#define MAX_IP 0x08
+#define MAX_SCTP 0x04
+#define MAX_ICMP 0x08
+#define MAX_IP 0x10
     char max_set = 0;
 
     if (config == NULL)
@@ -710,6 +727,47 @@ static void Stream5ParseGlobalArgs(Stream5GlobalConfig *config, char *args)
                            file_name, file_line);
             }
         }
+        else if(!strcasecmp(stoks[0], "max_sctp"))
+        {
+            if (stoks[1])
+            {
+                config->max_sctp_sessions = strtoul(stoks[1], &endPtr, 10);
+                if (config->track_sctp_sessions == S5_TRACK_YES)
+                {
+                    if ((config->max_sctp_sessions > S5_RIDICULOUS_MAX_SESSIONS) ||
+                        (config->max_sctp_sessions == 0))
+                    {
+                        FatalError("%s(%d) => 'max_sctp %d' invalid: value must be "
+                                   "between 1 and %d sessions\n",
+                                   file_name, file_line,
+                                   config->max_sctp_sessions,
+                                   S5_RIDICULOUS_MAX_SESSIONS);
+                    }
+                }
+            }
+
+            if (!stoks[1] || (endPtr == &stoks[1][0]))
+            {
+                FatalError("%s(%d) => Invalid max_sctp in config file.  Requires integer parameter.\n",
+                           file_name, file_line);
+            }
+            max_set |= MAX_SCTP;
+        }
+        else if(!strcasecmp(stoks[0], "track_sctp"))
+        {
+            if (stoks[1])
+            {
+                if(!strcasecmp(stoks[1], "no"))
+                    config->track_sctp_sessions = S5_TRACK_NO;
+                else
+                    config->track_sctp_sessions = S5_TRACK_YES;
+            }
+            else
+            {
+                FatalError("%s(%d) => 'track_sctp' missing option\n",
+                           file_name, file_line);
+            }
+        }
         else if(!strcasecmp(stoks[0], "max_icmp"))
         {
             if (stoks[1])
@@ -914,6 +972,12 @@ static void Stream5PrintGlobalConfig(Stream5GlobalConfig *config)
     if (config->track_udp_sessions == S5_TRACK_YES)
         LogMessage("    Max UDP sessions: %u\n",
             config->max_udp_sessions);
+    LogMessage("    Track SCTP sessions: %s\n",
+        config->track_sctp_sessions == S5_TRACK_YES ?
+        "ACTIVE" : "INACTIVE");
+    if (config->track_sctp_sessions == S5_TRACK_YES)
+        LogMessage("    Max SCTP sessions: %u\n",
+            config->max_sctp_sessions);
     LogMessage("    Track ICMP sessions: %s\n",
         config->track_icmp_sessions == S5_TRACK_YES ?
         "ACTIVE" : "INACTIVE");
@@ -1029,6 +1093,44 @@ static void Stream5PolicyInitUdp(char *args)
     Stream5UdpPolicyInit(config->udp_config, args);
 }
 
+static void Stream5PolicyInitSctp(char *args)
+{
+    tSfPolicyId policy_id = getParserPolicy();
+    Stream5Config *config;
+
+    if (s5_config == NULL)
+        FatalError("Tried to config stream5 SCTP policy without global config!\n");
+
+    sfPolicyUserPolicySet (s5_config, policy_id);
+    config = (Stream5Config *)sfPolicyUserDataGetCurrent(s5_config);
+
+    if ((config == NULL) || (config->global_config == NULL))
+    {
+        FatalError("Tried to config stream5 SCTP policy without global config!\n");
+    }
+
+    if (!config->global_config->track_sctp_sessions)
+    {
+#ifdef SNORT_RELOAD
+        /* Return if we're reloading - the discrepancy will be handled in
+         * the reload verify */
+        if (s5_swap_config != NULL)
+#endif
+            return;
+    }
+
+    if (config->sctp_config == NULL)
+    {
+        config->sctp_config =
+            (Stream5SctpConfig *)SnortAlloc(sizeof(Stream5SctpConfig));
+
+        Stream5InitSctp(config->global_config);
+    }
+
+    /* Call the protocol specific initializer */
+    Stream5SctpPolicyInit(config->sctp_config, args);
+}
+
 static void Stream5PolicyInitIcmp(char *args)
 {
     tSfPolicyId policy_id = getParserPolicy();
@@ -1112,6 +1214,7 @@ static void Stream5Reset(int signal, void *foo)
 
     Stream5ResetTcp();
     Stream5ResetUdp();
+    Stream5ResetSctp();
     Stream5ResetIcmp();
     Stream5ResetIp();
 
@@ -1123,6 +1226,7 @@ static void Stream5ResetStats(int signal, void *foo)
     memset(&s5stats, 0, sizeof(s5stats));
     Stream5ResetTcpPrunes();
     Stream5ResetUdpPrunes();
+    Stream5ResetSctpPrunes();
     Stream5ResetIcmpPrunes();
     Stream5ResetIpPrunes();
 }
@@ -1131,12 +1235,14 @@ static void Stream5CleanExit(int signal, void *foo)
 {
     s5stats.tcp_prunes = Stream5GetTcpPrunes();
     s5stats.udp_prunes = Stream5GetUdpPrunes();
+    s5stats.sctp_prunes = Stream5GetSctpPrunes();
     s5stats.icmp_prunes = Stream5GetIcmpPrunes();
     s5stats.ip_prunes = Stream5GetIpPrunes();
 
     /* Clean up the hash tables for these */
     Stream5CleanTcp();
     Stream5CleanUdp();
+    Stream5CleanSctp();
     Stream5CleanIcmp();
     Stream5CleanIp();
 
@@ -1160,6 +1266,7 @@ static int Stream5VerifyConfigPolicy(
 
     int tcpNotConfigured = 0;
     int udpNotConfigured = 0;
+    int sctpNotConfigured = 0;
     int icmpNotConfigured = 0;
     int ipNotConfigured = 0;
     int proto_flags = 0;
@@ -1214,6 +1321,26 @@ static int Stream5VerifyConfigPolicy(
         }
     }
 
+    if (pPolicyConfig->global_config->track_sctp_sessions)
+    {
+        sctpNotConfigured =
+            !pPolicyConfig->global_config->max_sctp_sessions ||
+            Stream5VerifySctpConfig(pPolicyConfig->sctp_config, policyId);
+
+        if (sctpNotConfigured)
+        {
+            ErrorMessage(
+                "WARNING: Stream5 SCTP misconfigured (policy %u)\n", policyId);
+        }
+        else
+        {
+            if ( !(s_proto_flags & PROTO_BIT__SCTP) )
+                s_sctp_sessions += pPolicyConfig->global_config->max_sctp_sessions;
+
+            proto_flags |= PROTO_BIT__SCTP;
+        }
+    }
+
     if (pPolicyConfig->global_config->track_icmp_sessions)
     {
         icmpNotConfigured =
@@ -1254,7 +1381,7 @@ static int Stream5VerifyConfigPolicy(
         }
     }
 
-    if ( tcpNotConfigured || udpNotConfigured || icmpNotConfigured || ipNotConfigured )
+    if ( tcpNotConfigured || udpNotConfigured || sctpNotConfigured || icmpNotConfigured || ipNotConfigured )
     {
         FatalError("Stream5 not properly configured... exiting\n");
     }
@@ -1278,14 +1405,14 @@ static void Stream5VerifyConfig(void)
     if (s5_config == NULL)
         return;
 
-    s_tcp_sessions = s_udp_sessions = 0;
+    s_tcp_sessions = s_udp_sessions = s_sctp_sessions = 0;
     s_icmp_sessions = s_ip_sessions = 0;
 
     sfPolicyUserDataIterate (s5_config, Stream5VerifyConfigPolicy);
 
     defConfig = sfPolicyUserDataGet(s5_config, getDefaultPolicy());
 
-    total_sessions = s_tcp_sessions + s_udp_sessions
+    total_sessions = s_tcp_sessions + s_udp_sessions + s_sctp_sessions
                    + s_icmp_sessions + s_ip_sessions;
 
     if ( !total_sessions )
@@ -1303,6 +1430,12 @@ static void Stream5VerifyConfig(void)
         LogMessage("UDP tracking disabled, no UDP sessions allocated\n");
     }
 
+    if ( (defConfig->global_config->max_sctp_sessions > 0)
+        && (s_sctp_sessions == 0) )
+    {
+        LogMessage("SCTP tracking disabled, no SCTP sessions allocated\n");
+    }
+
     if ( (defConfig->global_config->max_icmp_sessions > 0)
         && (s_icmp_sessions == 0) )
     {
@@ -1347,15 +1480,18 @@ static void Stream5PrintStats(int exiting)
     LogMessage("            Total sessions: %u\n",
             s5stats.total_tcp_sessions +
             s5stats.total_udp_sessions +
+            s5stats.total_sctp_sessions +
             s5stats.total_icmp_sessions +
             s5stats.total_ip_sessions);
     LogMessage("              TCP sessions: %u\n", s5stats.total_tcp_sessions);
     LogMessage("              UDP sessions: %u\n", s5stats.total_udp_sessions);
+    LogMessage("             SCTP sessions: %u\n", s5stats.total_sctp_sessions);
     LogMessage("             ICMP sessions: %u\n", s5stats.total_icmp_sessions);
     LogMessage("               IP sessions: %u\n", s5stats.total_ip_sessions);
 
     LogMessage("                TCP Prunes: %u\n", Stream5GetTcpPrunes());
     LogMessage("                UDP Prunes: %u\n", Stream5GetUdpPrunes());
+    LogMessage("               SCTP Prunes: %u\n", Stream5GetSctpPrunes());
     LogMessage("               ICMP Prunes: %u\n", Stream5GetIcmpPrunes());
     LogMessage("                 IP Prunes: %u\n", Stream5GetIpPrunes());
     LogMessage("TCP StreamTrackers Created: %u\n",
@@ -1370,12 +1506,16 @@ static void Stream5PrintStats(int exiting)
     LogMessage("         TCP Segments Used: %u\n", s5stats.tcp_rebuilt_seqs_used);
     LogMessage("              TCP Discards: %u\n", s5stats.tcp_discards);
     LogMessage("                  TCP Gaps: %u\n", s5stats.tcp_gaps);
-    LogMessage("      UDP Sessions Created: %u\n",
-            s5stats.udp_sessions_created);
-    LogMessage("      UDP Sessions Deleted: %u\n",
-            s5stats.udp_sessions_released);
+    LogMessage("      UDP Sessions Created: %u\n", s5stats.udp_sessions_created);
+    LogMessage("      UDP Sessions Deleted: %u\n", s5stats.udp_sessions_released);
     LogMessage("              UDP Timeouts: %u\n", s5stats.udp_timeouts);
     LogMessage("              UDP Discards: %u\n", s5stats.udp_discards);
+    LogMessage("     SCTP Sessions Created: %u\n", s5stats.sctp_sessions_created);
+    LogMessage("     SCTP Sessions Deleted: %u\n", s5stats.sctp_sessions_released);
+    LogMessage("      SCTP Messages Queued: %u\n", s5stats.sctp_streammsgs_created);
+    LogMessage("    SCTP Messages Released: %u\n", s5stats.sctp_streammsgs_released);
+    LogMessage("             SCTP Timeouts: %u\n", s5stats.sctp_timeouts);
+    LogMessage("             SCTP Discards: %u\n", s5stats.sctp_discards);
     LogMessage("                    Events: %u\n", s5stats.events);
     LogMessage("           Internal Events: %u\n", s5stats.internalEvents);
     LogMessage("           TCP Port Filter\n");
@@ -1386,6 +1526,10 @@ static void Stream5PrintStats(int exiting)
     LogMessage("                   Dropped: %u\n", s5stats.udp_port_filter.dropped);
     LogMessage("                 Inspected: %u\n", s5stats.udp_port_filter.inspected);
     LogMessage("                   Tracked: %u\n", s5stats.udp_port_filter.session_tracked);
+    LogMessage("          SCTP Port Filter\n");
+    LogMessage("                   Dropped: %u\n", s5stats.sctp_port_filter.dropped);
+    LogMessage("                 Inspected: %u\n", s5stats.sctp_port_filter.inspected);
+    LogMessage("                   Tracked: %u\n", s5stats.sctp_port_filter.session_tracked);
 }
 
 /*
@@ -1412,7 +1556,7 @@ void Stream5Process(Packet *p, void *context)
 
     PREPROC_PROFILE_START(s5PerfStats);
 
-    /* Call individual TCP/UDP/ICMP/IP processing, per GET_IPH_PROTO(p) */
+    /* Call individual TCP/UDP/SCTP/ICMP/IP processing, per GET_IPH_PROTO(p) */
     switch(GET_IPH_PROTO(p))
     {
         case IPPROTO_TCP:
@@ -1449,6 +1593,23 @@ void Stream5Process(Packet *p, void *context)
 
             break;
 
+        case IPPROTO_SCTP:
+            {
+                Stream5SctpPolicy *policy = NULL;
+
+                lwssn = GetLWSession(sctp_lws_cache, p, &key);
+                if (lwssn != NULL)
+                    policy = (Stream5SctpPolicy *)lwssn->policy;
+
+                if (Stream5SetRuntimeConfiguration(lwssn, IPPROTO_SCTP) == -1)
+                    return;
+
+                if (s5_global_eval_config->track_sctp_sessions)
+                    Stream5ProcessSctp(p, lwssn, policy, &key);
+            }
+
+            break;
+
         case IPPROTO_ICMP:
             if (Stream5SetRuntimeConfiguration(NULL, IPPROTO_ICMP) != -1)
             {
@@ -1502,6 +1663,15 @@ static inline int IsEligible(Packet *p)
                  return 0;
         }
         break;
+        case IPPROTO_SCTP:
+        {
+             if(p->sctph == NULL)
+                 return 0;
+
+             if (p->error_flags & PKT_ERR_CKSUM_SCTP)
+                 return 0;
+        }
+        break;
         case IPPROTO_ICMP:
         {
              if(p->icmph == NULL)
@@ -1721,7 +1891,9 @@ static int Stream5AlertFlushStream(Packet *p)
         return 0;
     }
 
-    if ((ssn->protocol != IPPROTO_TCP) ||
+
+    if (((ssn->protocol != IPPROTO_TCP) ||
+         (ssn->protocol != IPPROTO_SCTP)) ||
         (p->packet_flags & PKT_REBUILT_STREAM))
     {
         DEBUG_WRAP(DebugMessage(DEBUG_STREAM_STATE,
@@ -1751,7 +1923,9 @@ static int Stream5ResponseFlushStream(Packet *p)
     if (Stream5SetRuntimeConfiguration(ssn, ssn->protocol) == -1)
         return 0;
 
-    if ((ssn->protocol != IPPROTO_TCP) ||
+
+    if (((ssn->protocol != IPPROTO_TCP) ||
+         (ssn->protocol != IPPROTO_SCTP)) ||
         (p->packet_flags & PKT_REBUILT_STREAM))
     {
         DEBUG_WRAP(DebugMessage(DEBUG_STREAM_STATE,
@@ -1810,6 +1984,9 @@ static int Stream5AddSessionAlert(
 
     /* Don't need to do this for other protos because they don't
        do any reassembly. */
+    /* XXX: SCTP supports reassembly of DATA chunks, but Stream5 SCTP
+            is not complete yet.  For now, it mimics Stream5 UDP
+            functionality. */
     if ( GET_IPH_PROTO(p) != IPPROTO_TCP )
         return 0;
 
@@ -1835,6 +2012,9 @@ static int Stream5LogSessionAlertExtraData(
 
     /* Don't need to do this for other protos because they don't
        do any reassembly. */
+    /* XXX: SCTP supports reassembly of DATA chunks, but Stream5 SCTP
+            is not complete yet.  For now, it mimics Stream5 UDP
+            functionality. */
     if ( GET_IPH_PROTO(p) != IPPROTO_TCP )
         return 0;
 
@@ -1859,6 +2039,9 @@ static int Stream5CheckSessionAlert(
 
     /* Don't need to do this for other protos because they don't
        do any reassembly. */
+    /* XXX: SCTP supports reassembly of DATA chunks, but Stream5 SCTP
+            is not complete yet.  For now, it mimics Stream5 UDP
+            functionality. */
     if ( GET_IPH_PROTO(p) != IPPROTO_TCP )
         return 0;
 
@@ -1944,17 +2127,14 @@ static void Stream5StopInspection(
         return;
 
     /* Flush any queued data on the client and/or server */
-    if (ssn->protocol == IPPROTO_TCP)
+    if ((ssn->protocol == IPPROTO_TCP) ||
+        (ssn->protocol == IPPROTO_SCTP))
     {
         if (ssn->ignore_direction & SSN_DIR_CLIENT)
-        {
             Stream5FlushClient(p, ssn);
-        }
 
         if (ssn->ignore_direction & SSN_DIR_SERVER)
-        {
             Stream5FlushServer(p, ssn);
-        }
     }
 
     /* TODO: Handle bytes/response parameters */
@@ -2008,6 +2188,9 @@ static void Stream5UpdateDirection(
         case IPPROTO_UDP:
             UdpUpdateDirection(ssn, dir, ip, port);
             break;
+        case IPPROTO_SCTP:
+            SctpUpdateDirection(ssn, dir, ip, port);
+            break;
         case IPPROTO_ICMP:
             //IcmpUpdateDirection(ssn, dir, ip, port);
             break;
@@ -2089,7 +2272,7 @@ static int Stream5GetRebuiltPackets(
 {
     Stream5LWSession *ssn = (Stream5LWSession*)p->ssnptr;
 
-    if (!ssn || ssn->protocol != IPPROTO_TCP)
+    if (!ssn)
         return 0;
 
     /* Only if this is a rebuilt packet */
@@ -2099,7 +2282,22 @@ static int Stream5GetRebuiltPackets(
     if (Stream5SetRuntimeConfiguration(ssn, ssn->protocol) == -1)
         return 0;
 
-    return GetTcpRebuiltPackets(p, ssn, callback, userdata);
+    switch (ssn->protocol)
+    {
+        case IPPROTO_TCP:
+            return GetTcpRebuiltPackets(p, ssn, callback, userdata);
+            break;
+
+        /* Not functional yet.
+         * case IPPROTO_SCTP:
+         *   return GetSctpRebuiltPackets(p, ssn, callback, userdata);
+         *   break;
+         */   
+
+        default:
+            return 0;
+            break;
+    }
 }
 
 static int Stream5GetStreamSegments(
@@ -2109,7 +2307,7 @@ static int Stream5GetStreamSegments(
 {
     Stream5LWSession *ssn = (Stream5LWSession*)p->ssnptr;
 
-    if ((ssn == NULL) || (ssn->protocol != IPPROTO_TCP))
+    if (!ssn)
         return -1;
 
     /* Only if this is a rebuilt packet */
@@ -2119,7 +2317,22 @@ static int Stream5GetStreamSegments(
     if (Stream5SetRuntimeConfiguration(ssn, ssn->protocol) == -1)
         return -1;
 
-    return GetTcpStreamSegments(p, ssn, callback, userdata);
+    switch (ssn->protocol)
+    {
+        case IPPROTO_TCP:
+            return GetTcpStreamSegments(p, ssn, callback, userdata);
+            break;
+
+        /* Not functional yet
+         * case IPPROTO_SCTP:
+         *   return GetSctpStreamSegments(p, ssn, callback, userdata);
+         *   break;
+         */
+        
+        default:
+            return -1;
+            break;
+    }
 }
 
 static StreamFlowData *Stream5GetFlowData(Packet *p)
@@ -2147,39 +2360,83 @@ static char Stream5GetReassemblyDirection(void *ssnptr)
 {
     Stream5LWSession *ssn = (Stream5LWSession *)ssnptr;
 
-    if (!ssn || ssn->protocol != IPPROTO_TCP)
+    if (!ssn)
         return SSN_DIR_NONE;
 
     if (Stream5SetRuntimeConfiguration(ssn, ssn->protocol) == -1)
         return SSN_DIR_NONE;
 
-    return Stream5GetReassemblyDirectionTcp(ssn);
+    switch (ssn->protocol)
+    {
+        case IPPROTO_TCP:
+            return Stream5GetReassemblyDirectionTcp(ssn);
+            break;
+
+        /* Not functional yet.   
+         * case IPPROTO_SCTP:
+         *   return Stream5GetReassemblyDirectionSctp(ssn);
+         *   break;
+         */   
+
+        default:
+            return SSN_DIR_NONE;
+            break;
+    }
 }
 
 static uint32_t Stream5GetFlushPoint(void *ssnptr, char dir)
 {
     Stream5LWSession *ssn = (Stream5LWSession *)ssnptr;
 
-    if ((ssn == NULL) || (ssn->protocol != IPPROTO_TCP))
+    if (!ssn)
         return 0;
 
     if (Stream5SetRuntimeConfiguration(ssn, ssn->protocol) == -1)
         return 0;
 
-    return Stream5GetFlushPointTcp(ssn, dir);
+    switch (ssn->protocol)
+    {
+        case IPPROTO_TCP:
+            return Stream5GetFlushPointTcp(ssn, dir);
+            break;
+
+        /* Not functional yet.   
+         * case IPPROTO_SCTP:
+         *   return Stream5GetFlushPointSctp(ssn, dir);
+         *   break;
+         */   
+
+        default:
+            return 0;
+            break;
+    }
 }
 
 static void Stream5SetFlushPoint(void *ssnptr, char dir, uint32_t flush_point)
 {
     Stream5LWSession *ssn = (Stream5LWSession *)ssnptr;
 
-    if ((ssn == NULL) || (ssn->protocol != IPPROTO_TCP))
+    if (!ssn)
         return;
 
     if (Stream5SetRuntimeConfiguration(ssn, ssn->protocol) == -1)
         return;
 
-    Stream5SetFlushPointTcp(ssn, dir, flush_point);
+    switch (ssn->protocol)
+    {
+        case IPPROTO_TCP:
+            Stream5SetFlushPointTcp(ssn, dir, flush_point);
+            break;
+
+        /* Not functional yet.   
+         * case IPPROTO_SCTP:
+         *   Stream5SetFlushPointSctp(ssn, dir, flush_point);
+         *   break;
+         */   
+
+        default:
+            break;
+    }
 }
 
 static char Stream5SetReassembly(void *ssnptr,
@@ -2189,65 +2446,140 @@ static char Stream5SetReassembly(void *ssnptr,
 {
     Stream5LWSession *ssn = (Stream5LWSession *)ssnptr;
 
-    if (!ssn || ssn->protocol != IPPROTO_TCP)
+    if (!ssn)
         return 0;
 
     if (Stream5SetRuntimeConfiguration(ssn, ssn->protocol) == -1)
         return 0;
+    
+    switch (ssn->protocol)
+    {
+        case IPPROTO_TCP:
+            return Stream5SetReassemblyTcp(ssn, flush_policy, dir, flags);
+            break;
 
-    return Stream5SetReassemblyTcp(ssn, flush_policy, dir, flags);
+        /* Not functional yet.   
+         * case IPPROTO_SCTP:
+         *   return Stream5SetReassemblySctp(ssn, flush_policy, dir, flags);
+         *   break;
+         */   
+
+        default:
+            return 0;
+            break;
+    }
 }
 
 static char Stream5GetReassemblyFlushPolicy(void *ssnptr, char dir)
 {
     Stream5LWSession *ssn = (Stream5LWSession *)ssnptr;
 
-    if (!ssn || ssn->protocol != IPPROTO_TCP)
+    if (!ssn)
         return STREAM_FLPOLICY_NONE;
 
     if (Stream5SetRuntimeConfiguration(ssn, ssn->protocol) == -1)
         return STREAM_FLPOLICY_NONE;
 
-    return Stream5GetReassemblyFlushPolicyTcp(ssn, dir);
+    switch (ssn->protocol)
+    {
+        case IPPROTO_TCP:
+            return Stream5GetReassemblyFlushPolicyTcp(ssn, dir);
+            break;
+
+        /* Not functional yet.   
+         * case IPPROTO_SCTP:
+         *   return Stream5GetReassemblyFlushPolicySctp(ssn, dir);
+         *   break;
+         */   
+
+        default:
+            return STREAM_FLPOLICY_NONE;
+            break;
+    }
 }
 
 static char Stream5IsStreamSequenced(void *ssnptr, char dir)
 {
     Stream5LWSession *ssn = (Stream5LWSession *)ssnptr;
 
-    if (!ssn || ssn->protocol != IPPROTO_TCP)
+    if (!ssn)
         return 1;
 
     if (Stream5SetRuntimeConfiguration(ssn, ssn->protocol) == -1)
         return 1;
 
-    return Stream5IsStreamSequencedTcp(ssn, dir);
+    switch (ssn->protocol)
+    {
+        case IPPROTO_TCP:
+            return Stream5IsStreamSequencedTcp(ssn, dir);
+            break;
+
+        /* Not functional yet.   
+         * case IPPROTO_SCTP:
+         *   return Stream5IsStreamSequencedSctp(ssn, dir);
+         *   break;
+         */   
+
+        default:
+            return 1;
+            break;
+    }
 }
 
 static int Stream5MissingInReassembled(void *ssnptr, char dir)
 {
     Stream5LWSession *ssn = (Stream5LWSession *)ssnptr;
 
-    if (!ssn || ssn->protocol != IPPROTO_TCP)
+    if (!ssn)
         return SSN_MISSING_NONE;
 
     if (Stream5SetRuntimeConfiguration(ssn, ssn->protocol) == -1)
         return SSN_MISSING_NONE;
 
-    return Stream5MissingInReassembledTcp(ssn, dir);
+    switch (ssn->protocol)
+    {
+        case IPPROTO_TCP:
+            return Stream5MissingInReassembledTcp(ssn, dir);
+            break;
+
+        /* Not functional yet.   
+         * case IPPROTO_SCTP:
+         *   return Stream5MissingInReassembledSctp(ssn, dir);
+         *   break;
+         */   
+
+        default:
+            return SSN_MISSING_NONE;
+            break;
+    }
 }
 
 static char Stream5PacketsMissing(void *ssnptr, char dir)
 {
     Stream5LWSession *ssn = (Stream5LWSession *)ssnptr;
 
-    if (!ssn || ssn->protocol != IPPROTO_TCP)
+    if (!ssn)
         return 1;
 
     if (Stream5SetRuntimeConfiguration(ssn, ssn->protocol) == -1)
         return 1;
 
-    return Stream5PacketsMissingTcp(ssn, dir);
+    switch (ssn->protocol)
+    {
+        case IPPROTO_TCP:
+            return Stream5PacketsMissingTcp(ssn, dir);
+            break;
+
+        /* Not functional yet.   
+         * case IPPROTO_SCTP:
+         *   return Stream5PacketsMissingSctp(ssn, dir);
+         *   break;
+         */   
+
+        default:
+            return 1;
+            break;
+    }
 }
 
 static uint16_t s5GetPreprocessorStatusBit(void)
@@ -2272,11 +2604,18 @@ static void s5SetPortFilterStatus(
         case IPPROTO_TCP:
             s5TcpSetPortFilterStatus(port, status, policyId, parsing);
             break;
+
         case IPPROTO_UDP:
             s5UdpSetPortFilterStatus(port, status, policyId, parsing);
             break;
+
+        case IPPROTO_SCTP:
+            s5SctpSetPortFilterStatus(port, status, policyId, parsing);
+            break;
+
         case IPPROTO_ICMP:
             break;
+
         default:
             break;
     }
@@ -2366,6 +2705,9 @@ void Stream5SetIPProtocol(Stream5LWSession *lwssn)
     case IPPROTO_UDP:
         lwssn->ipprotocol = protocolReferenceUDP;
         break;
+    case IPPROTO_SCTP:
+        lwssn->ipprotocol = protocolReferenceSCTP;
+        break;
     case IPPROTO_ICMP:
         lwssn->ipprotocol = protocolReferenceICMP;
         break;
@@ -2428,7 +2770,8 @@ static void s5InitServiceFilterStatus(void)
         {
             RuleTreeNode *rtn = getRtnFromOtn(otn, policyId);
 
-            if (rtn && (rtn->proto == IPPROTO_TCP))
+            if (rtn && ((rtn->proto == IPPROTO_TCP) ||
+                        (rtn->proto == IPPROTO_SCTP)))
             {
                 unsigned int svc_idx;
 
@@ -2623,6 +2966,18 @@ int isPacketFilterDiscard(
 
             pPortFilterStats = &s5stats.udp_port_filter;
             break;
+
+        case IPPROTO_SCTP:
+            if ((s5_global_eval_config != NULL) &&
+                s5_global_eval_config->track_sctp_sessions)
+            {
+                action = s5SctpGetPortFilterStatus(p->sp, policy_id, 0) |
+                    s5SctpGetPortFilterStatus(p->dp, policy_id, 0);
+            }
+
+            pPortFilterStats = &s5stats.sctp_port_filter;
+            break;
+
         default:
             return PORT_MONITOR_PACKET_PROCESS;
     }
